=== plugins/CMakeLists.txt ===
add_subdirectory("datetime")
#add_subdirectory("disk-mount")
add_subdirectory("network")
add_subdirectory("shutdown")
add_subdirectory("power")
add_subdirectory("sound")
add_subdirectory("tray")
add_subdirectory("trash")
add_subdirectory("keyboard-layout")
add_subdirectory("onboard")
add_subdirectory("overlay-warning")
add_subdirectory("show-desktop")
add_subdirectory("multitasking")
add_subdirectory("bluetooth")
